@extends ('layouts.patient')
@section('inner-content')

    <?php

    function adjustBrightness($hex, $steps) {
        $steps = max(-255, min(255, $steps));
        $hex = str_replace('#', '', $hex);
        if (strlen($hex) == 3) {
            $hex = str_repeat(substr($hex,0,1), 2).str_repeat(substr($hex,1,1), 2).str_repeat(substr($hex,2,1), 2);
        }
        $color_parts = str_split($hex, 2);
        $return = '#';
        foreach ($color_parts as $color) {
            $color   = hexdec($color); // Convert to decimal
            $color   = max(0,min(255,$color + $steps)); // Adjust color
            $return .= str_pad(dechex($color), 2, '0', STR_PAD_LEFT); // Make two char hex code
        }
        return $return;
    }

    $palette = [
        ["bc" => '#522e92', "fc" => "#ffffff", "ac" => adjustBrightness('#522e92', 180) . 'aa'],
        ["bc" => '#003152', "fc" => "#ffffff", "ac" => adjustBrightness('#003152', 180) . 'aa'],
        ["bc" => '#111e6c', "fc" => "#ffffff", "ac" => adjustBrightness('#111e6c', 180) . 'aa'],
        ["bc" => '#1034a6', "fc" => "#ffffff", "ac" => adjustBrightness('#1034a6', 180) . 'aa'],
        ["bc" => '#0f52ba', "fc" => "#ffffff", "ac" => adjustBrightness('#0f52ba', 180) . 'aa'],
        ["bc" => '#447684', "fc" => "#ffffff", "ac" => adjustBrightness('#447684', 180) . 'aa'],
        ["bc" => '#d86700', "fc" => "#ffffff", "ac" => adjustBrightness('#d86700', 180) . 'aa'],
        ["bc" => '#643c07', "fc" => "#ffffff", "ac" => adjustBrightness('#643c07', 180) . 'aa'],
        ["bc" => '#ff3f3f', "fc" => "#ffffff", "ac" => adjustBrightness('#ff3f3f', 180) . 'aa'],
        ["bc" => '#ffa395', "fc" => "#222222", "ac" => adjustBrightness('#ffa395', 180) . 'aa'],
        ["bc" => '#6450ff', "fc" => "#ffffff", "ac" => adjustBrightness('#6450ff', 180) . 'aa'],
        ["bc" => '#8ec7f4', "fc" => "#222222", "ac" => adjustBrightness('#8ec7f4', 180) . 'aa'],
        ["bc" => '#522e92', "fc" => "#ffffff", "ac" => adjustBrightness('#522e92', 180) . 'aa'],
        ["bc" => '#111e6c', "fc" => "#ffffff", "ac" => adjustBrightness('#111e6c', 180) . 'aa'],
        ["bc" => '#003152', "fc" => "#ffffff", "ac" => adjustBrightness('#003152', 180) . 'aa'],
        ["bc" => '#1034a6', "fc" => "#ffffff", "ac" => adjustBrightness('#1034a6', 180) . 'aa'],
        ["bc" => '#0f52ba', "fc" => "#ffffff", "ac" => adjustBrightness('#0f52ba', 180) . 'aa'],
        ["bc" => '#447684', "fc" => "#ffffff", "ac" => adjustBrightness('#447684', 180) . 'aa'],
        ["bc" => '#d86700', "fc" => "#ffffff", "ac" => adjustBrightness('#d86700', 180) . 'aa'],
        ["bc" => '#643c07', "fc" => "#ffffff", "ac" => adjustBrightness('#643c07', 180) . 'aa'],
        ["bc" => '#ff3f3f', "fc" => "#ffffff", "ac" => adjustBrightness('#ff3f3f', 180) . 'aa'],
        ["bc" => '#ffa395', "fc" => "#222222", "ac" => adjustBrightness('#ffa395', 180) . 'aa'],
        ["bc" => '#6450ff', "fc" => "#ffffff", "ac" => adjustBrightness('#6450ff', 180) . 'aa'],
        ["bc" => '#8ec7f4', "fc" => "#222222", "ac" => adjustBrightness('#8ec7f4', 180) . 'aa'],
    ];
    ?>

    <link href="/select2/select2.min.css" rel="stylesheet" />
    <script src="/select2/select2.min.js"></script>
    <div id="ticketsApp" v-cloak>
        <div class="d-flex align-items-end pb-0">
            <h4 class="font-weight-bold m-0 font-size-14">Tickets</h4>
            <select class="ml-auto max-width-300px form-control form-control-sm pr-2"
                    v-model="statusFilter">
                <option value="open">Open tickets (@{{ numOpen }})</option>
                <option value="closed">Closed tickets (@{{ numClosed }})</option>
                <option value="all">All tickets (@{{ numAll }})</option>
            </select>
        </div>

        <div class="my-4">
            <div class="d-flex align-items-end mb-3">
                <h4 class="font-weight-bold m-0 text-secondary font-size-16">ERx
                    <span v-if="statusFilter === 'open'" class="text-secondary font-weight-normal">(@{{ erxNumOpen }} open)</span>
                    <span v-if="statusFilter === 'closed'" class="text-secondary font-weight-normal">(@{{ erxNumClosed }} closed)</span>
                    <span v-if="statusFilter === 'all'" class="text-secondary font-weight-normal">(@{{ erxNumOpen }} open, @{{ erxNumClosed }} closed)</span>
                </h4>
                <a class="py-1 px-3 c-pointer btn btn-sm btn-primary text-white mx-4 font-weight-bold"
                   v-on:click.prevent="showErxPopup()">Add</a>
                <a class="py-0 font-weight-normal c-pointer flex-grow-1 text-right pr-2"
                   v-if="!erxCollapsed"
                   v-on:click.prevent="erxCollapsed = true">
                    <i class="text-secondary fa fa-chevron-up"></i>
                </a>
                <a class="py-0 font-weight-normal c-pointer flex-grow-1 text-right pr-2"
                   v-if="erxCollapsed"
                   v-on:click.prevent="erxCollapsed = false">
                    <i class="text-secondary fa fa-chevron-down"></i>
                </a>
            </div>
            <div class="ticket-section" :class="erxCollapsed ? 'ticket-section-collapsed' : ''">
                <table class="table table-sm tickets-table mb-0">
                <tbody>
                <tr v-for="(item, index) in ticketsByType.erx"
                    v-if="statusFilter === 'all' || (statusFilter === 'open' && item.is_open) || (statusFilter === 'closed' && !item.is_open)"
                    :class="(item.is_open ? ' ' : 'opacity-60 bg-light ') + (currentItemUid === item.uid ? 'current' : '')">
                    <td class="px-2 py-2 c-pointer" v-on:click.prevent="showErxPopup(item)">
                        <div class="d-flex align-items-center">
                            <div class="pro-initials text-uppercase"
                                 :title="allProsFlat['pro_' + item.assigned_pro_id].displayedName"
                                 :style="'background-color: ' + allProsFlat['pro_' + item.assigned_pro_id].colors.bc + '; color: ' + allProsFlat['pro_' + item.assigned_pro_id].colors.fc + ';'">
                                @{{allProsFlat['pro_' + item.assigned_pro_id].displayedInitials}}
                            </div>
                            <div class="flex-grow-1 d-inline-flex ml-2 flex-wrap align-items-center">
                                <span class="font-weight-bold text-dark font-size-13">@{{item.data.medication}}</span>
                                <span class="d-inline-flex align-items-center" v-if="item.data.strength">
                                    <span class="mx-2 text-secondary">•</span>
                                    <span>@{{item.data.strength}}</span>
                                </span>
<!--                                <span class="d-inline-flex align-items-center" v-if="item.data.route">
                                    <span class="mx-2 text-secondary">•</span>
                                    <span>@{{item.data.route}}</span>
                                </span>
                                <span class="d-inline-flex align-items-center" v-if="item.data.frequency">
                                    <span class="mx-2 text-secondary">•</span>
                                    <span>@{{item.data.frequency}}</span>
                                </span>-->
                                <!--
                                <span class="d-inline-flex align-items-center" v-if="item.data.dispense">
                                    <span class="mx-2 text-secondary">•</span>
                                    <span>Dispense:</span> @{{item.data.dispense}}
                                    <span class="text-secondary ml-1" v-html="inWords(item.data.dispense)"></span>
                                </span>
                                <span class="d-inline-flex align-items-center" v-if="item.data.refills">
                                    <span class="mx-2 text-secondary">•</span>
                                    <span><span>Refills:</span> @{{item.data.refills}}</span>
                                </span>
                                <span class="d-inline-flex align-items-center" v-if="item.data.purpose">
                                    <span class="mx-2 text-secondary">•</span>
                                    <span><span>Purpose:</span> @{{item.data.purpose}}</span>
                                </span>
                                -->
                                <span class="text-nowrap ml-4 text-secondary" v-html="pharmacy(item.data)"></span>
                                <span class="text-nowrap ml-auto text-sm" v-if="item.data.due_date">
                                    <div title="Due Date" class="pro-initials text-uppercase text-white bg-info"><i class="fa fa-calendar-day"></i></div>
                                    <span class="text-secondary ml-1">@{{ item.data.due_date }}</span>
                                </span>
                            </div>
                        </div>
                        <!--
                        <div>
                            <span class="text-secondary text-sm mt-1">Created:</span>
                            @{{ item.created_at }}
                        </div>
                        -->
                    </td>
                    {{--@include('app.patient.tickets.ticket_vue_collab_column')--}}
                    {{--<td class="px-2">
                        <a class="mr-2 c-pointer" v-on:click.prevent="showPopup('erx-popup', item)">Edit</a>
                        <a class="mr-2 c-pointer" v-if="item.is_open" v-on:click.prevent="closeItem(item)">Close</a>
                        <a class="mr-2 c-pointer" v-if="!item.is_open" v-on:click.prevent="openItem(item)">Open</a>

                        @include('app.patient.partials.ticket_action_links')
                    </td>--}}
                </tr>
                </tbody>
            </table>
            </div>
            <div class="stag-popup stag-popup-sm stag-slide mcp-theme-1" stag-popup-key="erx-popup">
                <form method="POST" action="" class="p-0">
                    <h3 class="stag-popup-title mb-0 p-3 bg-light">
                        <span class="text-nowrap overflow-hidden text-ellipsis mr-3">@{{ erxPopupMode === 'add' ? 'Add ERx Ticket' : erxPopupItem.data.medication + '  •  ' + erxPopupItem.data.strength }}</span>
                        <div v-if="erxPopupMode === 'edit'" class="ml-auto mr-3">
                            <a v-if="erxPopupItem.is_open" href="#"
                               class="btn btn-sm btn-default border bg-white text-dark text-nowrap shadow-none"
                               v-on:click.prevent="closeItem(erxPopupItem)">
                                <i class="fa fa-check text-success mr-2"></i>Mark Complete
                            </a>
                            <a v-if="!erxPopupItem.is_open" href="#"
                               class="btn btn-sm btn-success text-nowrap text-white shadow-none"
                               v-on:click.prevent="openItem(erxPopupItem)">
                                <i class="fa fa-check mr-2"></i>Complete
                            </a>
                        </div>
                        <a href="#" class="text-secondary"
                           onclick="return closeStagPopup()"><i class="fa fa-chevron-right"></i></a>
                    </h3>

                    <!-- common - only applicable for edit -->
                    <div class="p-3 border-bottom">

                        <div v-if="erxPopupMode === 'edit'">
                            <div class="row mb-2">
                                <div class="col-3 d-inline-flex align-items-center">
                                    <label class="text-secondary m-0">Assigned Pro</label>
                                </div>
                                <div class="col-9">
                                    <div class="d-flex align-items-center">
                                        <div class="pro-initials text-uppercase"
                                             :title="allProsFlat['pro_' + erxPopupItem.assigned_pro_id].displayedName"
                                             :style="'background-color: ' + allProsFlat['pro_' + erxPopupItem.assigned_pro_id].colors.bc + '; color: ' + allProsFlat['pro_' + erxPopupItem.assigned_pro_id].colors.fc + ';'">
                                            @{{allProsFlat['pro_' + erxPopupItem.assigned_pro_id].displayedInitials}}
                                        </div>
                                        <div class="flex-grow-1 ml-2">
                                            <select provider-search
                                                    data-field="assigned_pro_uid"
                                                    v-model="erxPopupItem.assigned_pro_uid"
                                                    :data-pro-name="[erxPopupItem.assigned_pro.name_last, erxPopupItem.assigned_pro.name_first].filter(Boolean).join(', ')"
                                                    class="form-control form-control-sm">
                                                <option value=""> --select--</option>
                                            </select>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="row mb-2">
                                <div class="col-3 d-inline-flex align-items-center">
                                    <label class="text-secondary m-0">Ordering Pro</label>
                                </div>
                                <div class="col-9">
                                    <div class="d-flex align-items-center">
                                        <div class="pro-initials text-uppercase"
                                             :title="allProsFlat['pro_' + erxPopupItem.ordering_pro_id].displayedName"
                                             :style="'background-color: ' + allProsFlat['pro_' + erxPopupItem.ordering_pro_id].colors.bc + '; color: ' + allProsFlat['pro_' + erxPopupItem.ordering_pro_id].colors.fc + ';'">
                                            @{{allProsFlat['pro_' + erxPopupItem.ordering_pro_id].displayedInitials}}
                                        </div>
                                        <div class="flex-grow-1 ml-2">
                                            <select provider-search
                                                    data-field="ordering_pro_uid"
                                                    v-model="erxPopupItem.ordering_pro_uid"
                                                    :data-pro-name="[erxPopupItem.ordering_pro.name_last, erxPopupItem.ordering_pro.name_first].filter(Boolean).join(', ')"
                                                    class="form-control form-control-sm">
                                                <option value=""> --select--</option>
                                            </select>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-3 d-inline-flex align-items-center">
                                <label class="text-secondary m-0">Due Date</label>
                            </div>
                            <div class="col-9">
                                <div class="d-flex align-items-center">
                                    <div class="pro-initials text-uppercase text-white bg-info"
                                         title="Due Date">
                                        <i class="fa fa-calendar-day"></i>
                                    </div>
                                    <div class="flex-grow-1 ml-2">
                                        <input type="text" data-field="due_date" placeholder="Due Date"
                                               v-model="erxPopupItem.data.due_date" class="form-control form-control-sm date-input">
                                    </div>
                                </div>
                            </div>
                        </div>

                    </div>

                    <div class="p-3 border-bottom">

                        <div class="row mb-2">
                            <div class="col-12">
                                <label class="text-secondary mb-0 font-weight-bold font-size-13">ERx</label>
                            </div>
                        </div>
                        <div class="row mb-2">
                            <div class="col-9">
                                <label class="text-sm text-secondary mb-1">Medication</label>
                                <input type="hidden" v-model="erxPopupItem.data.medication">
                                <input required type="text" data-field="medication" placeholder="Medication"
                                       :value="erxPopupItem.data.medication"
                                       class="form-control form-control-sm">
                            </div>
                            <div class="col-3 pl-0">
                                <label class="text-sm text-secondary mb-1">Strength</label>
                                <input type="hidden" v-model="erxPopupItem.data.strength">
                                <input type="text" data-field="strength" placeholder="Strength"
                                       :value="erxPopupItem.data.strength"
                                       class="form-control form-control-sm min-width-unset">
                            </div>
                        </div>
                        <div class="row mb-2">
                            <div class="col-3">
                                <label class="text-sm text-secondary mb-1">Frequency</label>
                                <input type="text" placeholder="Frequency"
                                       v-model="erxPopupItem.data.frequency" class="form-control form-control-sm min-width-unset"
                                       data-option-list="frequency-options">
                                <div id="frequency-options" class="data-option-list">
                                    <div>Once a day</div>
                                    <div>Twice a day</div>
                                </div>
                            </div>
                            <div class="col-3 pl-0">
                                <label class="text-sm text-secondary mb-1">Route</label>
                                <input required type="text" placeholder="Route"
                                       v-model="erxPopupItem.data.route" class="form-control form-control-sm min-width-unset"
                                       data-option-list="route-options">
                                <div id="route-options" class="data-option-list">
                                    <div>PO (by mouth)</div>
                                    <div>PR (per rectum)</div>
                                    <div>IM (intramuscular)</div>
                                    <div>IV (intravenous)</div>
                                    <div>ID (intradermal)</div>
                                    <div>IN (intranasal)</div>
                                    <div>TP (topical)</div>
                                    <div>SL (sublingual)</div>
                                    <div>BUCC (buccal)</div>
                                    <div>IP (intraperitoneal)</div>
                                </div>
                            </div>
                            <div class="col-3 pl-0">
                                <label class="text-sm text-secondary mb-1">Dispense Amount</label>
                                <input required type="number" placeholder="Dispense Amount"
                                       v-model="erxPopupItem.data.dispense" class="form-control form-control-sm min-width-unset">
                            </div>
                            <div class="col-3 pl-0">
                                <label class="text-sm text-secondary mb-1">Refills</label>
                                <input type="number" placeholder="Refills"
                                       v-model="erxPopupItem.data.refills" class="form-control form-control-sm min-width-unset">
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-12">
                                <label class="text-sm text-secondary mb-1">Purpose</label>
                                <input required type="text"  placeholder="Purpose"
                                       data-field="icd" v-model="erxPopupItem.data.purpose" class="form-control form-control-sm">
                            </div>
                        </div>

                    </div>
                    <div class="p-3 border-bottom">
                        <div class="row mb-2">
                            <div class="col-12">
                                <label class="text-secondary mb-0 font-weight-bold font-size-13">Preferred Pharmacy</label>
                            </div>
                        </div>
                        <div class="row mb-2">
                            <div class="col-12">
                                <label class="text-sm text-secondary mb-1">Business Name</label>
                                <input type="text" autocomplete="donotdoit" placeholder="Business Name" id="pharmacy-search" v-model="erxPopupItem.data.pharmacyName" class="form-control form-control-sm">
                                <div class="suggestions-outer pharmacy-suggestions position-absolute d-none"></div>
                            </div>
                        </div>
                        <div class="row mb-2">
                            <div class="col-4">
                                <label class="text-sm text-secondary mb-1">City</label>
                                <input type="text" placeholder="City" v-model="erxPopupItem.data.pharmacyCity" class="form-control form-control-sm min-width-unset">
                            </div>
                            <div class="col-2 pl-0">
                                <label class="text-sm text-secondary mb-1">State</label>
                                <input type="text" placeholder="State" v-model="erxPopupItem.data.pharmacyState" class="form-control form-control-sm min-width-unset">
                            </div>
                            <div class="col-3 pl-0">
                                <label class="text-sm text-secondary mb-1">Phone</label>
                                <input type="text" placeholder="Phone" v-model="erxPopupItem.data.pharmacyPhone" class="form-control form-control-sm min-width-unset">
                            </div>
                            <div class="col-3 pl-0">
                                <label class="text-sm text-secondary mb-1">Fax</label>
                                <input type="text" placeholder="Fax" v-model="erxPopupItem.data.pharmacyFax" class="form-control form-control-sm min-width-unset">
                            </div>
                        </div>
                        <div class="row mb-2">
                            <div class="col-12">
                                <label class="text-sm text-secondary mb-1">Address Memo</label>
                                <input type="text" placeholder="Address Memo" autocomplete="donotdoit" v-model="erxPopupItem.data.pharmacyAddressMemo" class="form-control form-control-sm">
                            </div>
                        </div>
                        <div v-if="erxPopupMode === 'add'" class="d-flex align-items-center justify-content-start mt-3">
                            <button type="button" class="btn btn-sm btn-primary mr-2" v-on:click.prevent="saveErxPopupItem()">Submit</button>
                            <button type="button" class="btn btn-sm btn-default border" onclick="return closeStagPopup()">Cancel</button>
                        </div>
                    </div>
                </form>
            </div>
            @include('app.patient.partials.ticket_update_pro_form',['ticketType'=>'erx'])
        </div>

    </div>

    <script>
        (function() {
            const debounce = (func, delay) => {
                let debounceTimer
                return function() {
                    const context = this
                    const args = arguments
                    clearTimeout(debounceTimer)
                    debounceTimer
                        = setTimeout(() => func.apply(context, args), delay)
                }
            }
            <?php
            $tickets = $patient->tickets;

            $ticketsByType = [
                "erx" => [],
                "equipment" => [],
                "lab" => [],
                "imaging" => [],
            ];

            $ticketsArray = [];
            foreach ($tickets as $ticket) {
                $ticket->data = json_decode($ticket->data);
                $ticket->created_at = friendly_date_time($ticket->created_at);
                $ticket->assignedPro;
                $ticket->managerPro;
                $ticket->orderingPro;
                $ticket->initiatingPro;
                $ticketsByType[$ticket->category][] = $ticket;
                $ticketsArray[] = $ticket;
            }

            $allProsFlat = [];
            $paletteIndex = 0;
            foreach ($allPros as $allPro) {
                $allPro->displayedName = $allPro->displayName();
                $allPro->displayedInitials = $allPro->initials();
                $allProsFlat["pro_" . $allPro->id] = $allPro;
                $allProsFlat["pro_" . $allPro->id]['colors'] = $palette[$paletteIndex++];
                if($paletteIndex >= count($palette)) $paletteIndex = 0;
            }
            ?>
            function init() {
                window.ticketsApp = new Vue({
                    el: '#ticketsApp',
                    delimiters: ['@{{', '}}'],
                    data: {
                        tickets: {!! json_encode($ticketsArray) !!},
                        ticketsByType: {!! json_encode($ticketsByType) !!},

                        statusFilter: 'open',

                        // erx
                        erxCollapsed: false,
                        erxPopupMode: 'add',
                        erxPopupItem: {
                            uid: '',
                            is_open: true,
                            assigned_pro_uid: '',
                            ordering_pro_uid: '',
                            data: {
                                due_date: '',
                                medication: '',
                                strength: '',
                                amount: '',
                                route: '',
                                frequency: '',
                                dispense: '',
                                refills: '',
                                purpose: '',
                                pharmacyName: '',
                                pharmacyCity: '',
                                pharmacyState: '',
                                pharmacyAddressMemo: '',
                                pharmacyPhone: '',
                                pharmacyFax: '',
                                comments: [],
                            }
                        },

                        // lab
                        labPopupMode: 'add',
                        labPopupItem: {
                            uid: '',
                            is_open: true,
                            tests: [''],
                            icds: [''],
                            memo: '',
                        },

                        // common
                        currentItemUid: '',
                        allPros: {!! json_encode($allPros) !!},
                        allProsFlat: {!! json_encode($allProsFlat) !!},
                        proToUpdate: '',
                        proTypes: ['Assigned', 'Manager', 'Initiating', 'Ordering'],
                        newProUid: '',
                        reloading: false,

                        // debounced auto-saver
                        autoSave: null,
                    },
                    computed: {
                        numAll: function() {
                            return this.tickets.length;
                        },
                        numOpen: function() {
                            return this.tickets.filter(_x => _x.is_open).length;
                        },
                        numClosed: function() {
                            return this.tickets.filter(_x => !_x.is_open).length;
                        },
                        erxNumAll: function() {
                            return this.ticketsByType.erx.length;
                        },
                        erxNumOpen: function() {
                            return this.ticketsByType.erx.filter(_x => _x.is_open).length;
                        },
                        erxNumClosed: function() {
                            return this.ticketsByType.erx.filter(_x => !_x.is_open).length;
                        },
                        erxCurrentItemData: function() {
                            return this.erxPopupItem.data;
                        }
                    },
                    watch: {
                        erxCurrentItemData: {
                            handler: function(val, oldVal) {
                                if (this.erxPopupMode !== 'edit' || !this.currentItemUid || this.reloading) return;
                                this.autoSave();
                            },
                            deep: true
                        }
                    },
                    methods: {

                        // erx
                        showErxPopup: function(_item) {
                            this.erxPopupMode = _item ? 'edit' : 'add';
                            this.erxPopupItem = _item ? JSON.parse(JSON.stringify(_item)) : {
                                uid: '',
                                is_open: true,
                                assigned_pro_uid: '',
                                ordering_pro_uid: '',
                                data: {
                                    due_date: '',
                                    medication: '',
                                    strength: '',
                                    amount: '',
                                    route: '',
                                    frequency: '',
                                    dispense: '',
                                    refills: '',
                                    purpose: '',
                                    pharmacyName: '',
                                    pharmacyCity: '',
                                    pharmacyState: '',
                                    pharmacyAddressMemo: '',
                                    pharmacyPhone: '',
                                    pharmacyFax: '',
                                    comments: [],
                                }
                            };
                            this.erxPopupItem.assigned_pro_uid = '';
                            this.erxPopupItem.ordering_pro_uid = '';
                            showStagPopup('erx-popup', true);
                            Vue.nextTick(() => {
                                $('#ticketsApp [pro-suggest-initialized]').removeAttr('pro-suggest-initialized');
                                initProSuggest();
                                if (_item) {
                                    this.currentItemUid = _item.uid;
                                }
                            });
                        },
                        saveErxPopupItem: function(_autoSave = false) {
                            let form = $('#ticketsApp form').first();

                            if(!_autoSave) {
                                if(!form[0].checkValidity()) {
                                    form[0].reportValidity();
                                    return false;
                                }
                            }

                            if(!_autoSave) showMask();
                            let payload = {};
                            if(this.erxPopupMode === 'add') {
                                payload.clientUid = '{{ $patient->uid }}';
                                payload.category = 'erx';
                                payload.assignedProUid = '{{ $pro->uid  }}';
                                payload.managerProUid = '{{ $pro->uid  }}';
                                payload.orderingProUid = '{{ $pro->uid  }}';
                                payload.initiatingProUid = '{{ $pro->uid  }}';
                                payload.data = JSON.stringify(this.erxPopupItem.data);
                            }
                            else {
                                payload.uid = this.erxPopupItem.uid;
                                payload.newData = JSON.stringify(this.erxPopupItem.data);
                            }

                            $.post(
                                '/api/ticket/' + (this.erxPopupMode === 'add' ? 'create' : 'updateData'),
                                payload,
                                (_data) => {
                                    console.log(_data);
                                    if(!_autoSave) {
                                        fastReload();
                                    }
                                    else {
                                        this.reloadPopupItem('erx');
                                    }
                                },
                                'json');

                            return false;
                        },

                        // lab

                        // imaging

                        // equipment

                        // common
                        reloadPopupItem: function(_type) {
                            this.reloading = true;
                            $.get('/get-ticket/' + this[_type + 'PopupItem'].uid, (_data) => {
                                this[_type + 'PopupItem'] = _data;

                                // also update in main list
                                for (let i=0; i < this.ticketsByType[_type].length; i++) {
                                    if (this.ticketsByType[_type][i].uid === this[_type + 'PopupItem'].uid) {
                                        this.ticketsByType[_type].splice(i, 1, _data);
                                        break;
                                    }
                                }

                                Vue.nextTick(() => {
                                    this.reloading = false;
                                });

                            }, 'json');
                        },
                        closeItem: function(_item) {
                            $.post('/api/ticket/close', {
                                uid: _item.uid
                            }, (_data) => {
                                this.reloadPopupItem('erx');
                            });
                        },
                        openItem: function(_item) {
                            $.post('/api/ticket/open', {
                                uid: _item.uid
                            }, (_data) => {
                                this.reloadPopupItem('erx');
                            });
                        },
                        initRxAutoSuggest: function() {
                            let self = this;
                            $('#ticketsApp input[type="text"][data-field="medication"]:not([ac-initialized])').each(function() {
                                let elem = this,
                                    randPart = Math.ceil(Math.random() * 1000000),
                                    dynID = 'rx-' + randPart;
                                $(elem).attr('id', dynID);
                                var strengthElem = $(elem).closest('.stag-popup').find('[data-field="strength"]')[0],
                                    dynStrengthsID = 'rx-' + randPart + '-strengths';
                                $(strengthElem).attr('id', dynStrengthsID);
                                $(strengthElem).attr('rx-id', dynID);
                                new window.Def.Autocompleter.Prefetch(dynStrengthsID, []);
                                new window.Def.Autocompleter.Search(dynID,
                                    'https://clinicaltables.nlm.nih.gov/api/rxterms/v3/search?ef=STRENGTHS_AND_FORMS');
                                window.Def.Autocompleter.Event.observeListSelections(dynID, function() {
                                    var autocomp = elem.autocomp, acData = autocomp.getSelectedItemData();
                                    var strengths = acData[0].data['STRENGTHS_AND_FORMS'];
                                    if (strengths) {
                                        strengthElem.autocomp.setListAndField(strengths, '');
                                    }
                                    self.erxPopupItem.data.medication = $(elem).val();
                                });
                                window.Def.Autocompleter.Event.observeListSelections(dynStrengthsID, function() {
                                    var autocomp = elem.autocomp, acData = autocomp.getSelectedItemData();
                                    self.erxPopupItem.data.strength = $(strengthElem).val();
                                });
                                $(elem).attr('ac-initialized', 1);
                                $(strengthElem).attr('ac-initialized', 1);
                            });
                        },
                        initICDAutoSuggest: function() {
                            let self = this;
                            $('#ticketsApp input[type="text"][data-field="icd"]:not([ac-initialized])').each(function() {
                                var elem = this,
                                    dynID = 'icd-' + Math.ceil(Math.random() * 1000000),
                                    vueIndex = $(this).attr('data-index');
                                $(elem).attr('id', dynID);
                                new window.Def.Autocompleter.Search(dynID,
                                    'https://clinicaltables.nlm.nih.gov/api/icd10cm/v3/search?sf=code,name&ef=name', {
                                        tableFormat: true,
                                        valueCols: [0],
                                        colHeaders: ['Code', 'Name'],
                                    }
                                );
                                window.Def.Autocompleter.Event.observeListSelections(dynID, function() {
                                    let autocomp = elem.autocomp, acData = autocomp.getSelectedItemData();
                                    self.erxPopupItem.data.purpose = acData[0].code + ' - ' + acData[0].data.name;
                                    return false;
                                });
                                $(elem).attr('ac-initialized', 1);
                            });
                        },
                        initDomElementEvents: function() {
                            let self = this;
                            $(document).off('pro-changed', '#ticketsApp select[provider-search]')
                            $(document).on('pro-changed', '#ticketsApp select[provider-search]', function() {
                                console.log('ALIX pro-changed', $(this).attr('data-field'), $(this).val());
                                if(!!$(this).val()) {
                                    self.erxPopupItem[$(this).attr('data-field')] = $(this).val();

                                    // save
                                    let proType = '';
                                    switch($(this).attr('data-field')) {
                                        case 'assigned_pro_uid':
                                            proType = 'Assigned';
                                            break;
                                        case 'ordering_pro_uid':
                                            proType = 'Ordering';
                                            break;
                                    }
                                    if (proType) {
                                        $.post('/api/ticket/update' + proType + 'Pro', {
                                            uid: self.erxPopupItem.uid,
                                            newProUid: $(this).val()
                                        }, function(_data) {
                                            if (!self.hasError(_data)) {
                                                // toastr.success(proType + ' pro updated');
                                                self.reloadPopupItem('erx');
                                            }
                                        });
                                    }
                                }
                            });

                            $(document).off('stag-popup-closed')
                            $(document).on('stag-popup-closed', function() {
                                self.currentItemUid = '';
                            });

                            $('input.date-input')
                                .datepicker({
                                    autoclose: true,
                                    todayHighlight: true,
                                    format: 'yyyy-mm-dd'
                                })
                                .off('changeDate')
                                .on('changeDate', function() {
                                    self.erxPopupItem.data.due_date = $(this).val();
                                });

                            $(document).off('focus', '#ticketsApp input.form-control');
                            $(document).on('focus', '#ticketsApp input.form-control', function() {
                                $(this).select();
                            });
                        },
                        inWords: function (num) {
                            try {
                                num = +num;
                                var a = ['','one ','two ','three ','four ', 'five ','six ','seven ','eight ','nine ','ten ','eleven ','twelve ','thirteen ','fourteen ','fifteen ','sixteen ','seventeen ','eighteen ','nineteen '];
                                var b = ['', '', 'twenty','thirty','forty','fifty', 'sixty','seventy','eighty','ninety'];
                                if ((num = num.toString()).length > 3) return 'overflow';
                                let n = ('000000000' + num).substr(-9).match(/^(\d{2})(\d{2})(\d{2})(\d{1})(\d{2})$/);
                                if (!n) return; var str = '';
                                str += (n[1] != 0) ? (a[Number(n[1])] || b[n[1][0]] + ' ' + a[n[1][1]]) + 'crore ' : '';
                                str += (n[2] != 0) ? (a[Number(n[2])] || b[n[2][0]] + ' ' + a[n[2][1]]) + 'lakh ' : '';
                                str += (n[3] != 0) ? (a[Number(n[3])] || b[n[3][0]] + ' ' + a[n[3][1]]) + 'thousand ' : '';
                                str += (n[4] != 0) ? (a[Number(n[4])] || b[n[4][0]] + ' ' + a[n[4][1]]) + 'hundred ' : '';
                                str += (n[5] != 0) ? ((str != '') ? 'and ' : '') + (a[Number(n[5])] || b[n[5][0]] + ' ' + a[n[5][1]]) : '';
                                return str ? '(' + $.trim(str) + ')' : '';
                            }
                            catch (e) {
                                return '';
                            }
                        },
                        pharmacy: function(_item) {
                            return [
                                _item.pharmacyName,
                                _item.pharmacyCity,
                                /*_item.pharmacyState,
                                _item.pharmacyAddressMemo,
                                _item.pharmacyPhone,
                                _item.pharmacyFax,*/
                            ].filter(Boolean).join(', ');
                        },
                        @include('app.patient.tickets.pharmacy-suggest')
                        @include('app.patient.tickets.ticket_vue_methods',['ticketType'=>'erx'])
                    },
                    mounted: function () {
                        this.initRxAutoSuggest();
                        this.initICDAutoSuggest();
                        initFastLoad($('#ticketsApp'));
                        this.initPharmacySearch();
                        this.initDomElementEvents();
                        this.autoSave = debounce(() => {
                            this.saveErxPopupItem(true);
                        }, 1000);
                    }
                })
            }
            addMCInitializer('patient-tickets', init, '#ticketsApp');
        })();
    </script>

@endsection
